﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkID=392286
(function () {

    var onerrorCt = 0;
    WinJS.Application.onerror = function (e) {
        onerrorCt++;
        var cons = [],
            history = window.console.history,
            entries = 1,
            entry;
        try {
            var message = (e.detail.error && e.detail.error.message) || e.detail.errorMessage || '-',
                    line = (e.detail.error && e.detail.error.lineno) || e.detail.errorLine || '-';
       
            // Don't flood the beacon server
            if (onerrorCt < 5) {
                try {
                    if (history) {
                        while (entries <= 5) {
                            // remove the ending ' ||'
                            entry = history[history.length - entries].replace(/(\s\|\|)$/, '');
                            cons.push(entry.substr(0, 50));
                            entries++;
                        }
                    }
                } catch(e2) {}
                cons = cons.length ? cons.join(' || ') : '-';

                beacon({
                    type: "windowsApplicationError",
                    message: encodeURIComponent(message),
                    line: encodeURIComponent(line),
                    console: cons // show the last 3 console entries
                });

                if (isBeta) {
                    sendLogEmail();
                }
            }
        } catch(e3) {
        }
        // forcing the true state
        return true;
    };

    var nativeConsole = window.console;

    window.console = new function () {
        var _this = this,
        history = [];

        _this.log = function () {
            var line = [];
            for (var i = 0; i < arguments.length; i++) {
                if (arguments[i]) {
                    line.push(arguments[i]);
                }
            }

            // append to the history
            if (line.length) {
                history.push(line.join(' | ') + ' ||');
                if (history[history.length - 1] == ' ||') {
                    var here = '';
                }
                if (history.length > 100) {
                    history.splice(0, 1);
                }
            }
            // IMPORTANT: Don't check in the following line un-commented. The app will not load
            //nativeConsole.log.apply(window, arguments);
        }
        _this.history = history;
    }

    /*
    setTimeout(
        function () { window.xyz() },
        5000
    );
    */
    



    var launchStartTime = Date.now();
    var launchUrl = "http://cdn.shazam.com/sftv/{build}/shazam.html#apps.shazam;activepage=apps.shazam.listen";
    var localUrl = "ms-appx-web:///sftv/publicoffline/shazam.html?apps.shazam;offline=1;activepage=apps.shazam.listen";
    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;
    var applicationData = Windows.Storage.ApplicationData.current;
    var localSettings = applicationData.localSettings;
    var localFolder = applicationData.localFolder;
    var history = [];
    var backButton;
    var appState = { foo: "bar" };
    var appStateFileName = "AppState.json";
    var checkForLatestDelay = 10000;
    var launchVer = 'local';
    var networkInformation = Windows.Networking.Connectivity.NetworkInformation;
    var appVersion = window.localStorage["appVersion"];
    var migrationAttempted = window.localStorage["migrationAttempted"];
    var migrated4_1 = window.localStorage["migrated_4_1_1"];
    var webview, youtubeview, initialized, activeVoiceCommand, activeTile, isBeta, isEncore, sharedata, webappReady;
    var isChannelBuild, insideBack, installationIdMigration, isLowMemoryDevice;
    var timeVisible = 0;
    var aboutData = {
        client: {
            version:'4.0.0.0' // default version
        }
    };
    var beaconUrl;
    var bounds;
    var tombstone;
    var deeplinkView;
    var startup = { type: "startupTimeout" };
    var isPhone;
    var secondWebView;
    var secondWebViewContainer;
    var secondWebViewOnScreen;
    var youTubeOnScreen;
    var batteryBarOffset;
    var widthRatio = Windows.Phone ? window.innerWidth / 320:1;
    var authenticationResult;
    var deepLinkResult;
    var secondWebViewFullScreen;
    var navRect = { left: 0, top: 0, width: 0, height: 0 };

    var loadingStrings = {
        cs: "Načítání",
        de: "Wird geladen",
        es: "Cargando",
        fr: "Chargement",
        it: "Caricamento",
        ko: "로드 중",
        pl: "Wczytywanie",
        "pt-pt": "A carregar",
        ru:  "Загрузка",
        "zh-hant": "正在載入"
    }

    function alert(body, title, commands, cb) {
        console.log('-*-alert');
        var msgBox = new Windows.UI.Popups.MessageDialog(body, title);
        if (commands && cb && Object.prototype.toString.call( commands ) === '[object Array]') {
            commands.forEach(function (command, i) {
                msgBox.commands.append(new Windows.UI.Popups.UICommand(command));
                if (commands.length - 1 === i) {
                    msgBox.cancelCommandIndex = i;
                }
            });
        }        
        msgBox.showAsync().done(function (arg) {
            if (arg && arg.label) {
                cb && cb(arg.label)
            } else {
                cb && cb();
            }            
        });
    }

    window.alert = alert;

    // application resuming
    Windows.UI.WebUI.WebUIApplication.addEventListener("resuming", function (e) {
        console.log('-*-resume');
        reflowWebView();
        WebBridge.broadcast(webview, 'NativeBridge:receive', {
            type: 'applicationForegrounded',
            data: null
        });

    }, false);

    function readAppState(cb) {
        console.log("-*-readAppState Start: ", Date.now() - launchStartTime);

        localFolder.createFileAsync(appStateFileName, Windows.Storage.CreationCollisionOption.openIfExists)
        .done(function (appStateFile) {
            Windows.Storage.FileIO.readTextAsync(appStateFile).done(function (fileContent) {
                try {
                    if (fileContent) {
                        appState = JSON.parse(fileContent);
                    }
                    //      appState['pendingTags'] = null;
                } catch (e) {
                    console.log("-*-readAppState Failure: " + e);
                }
                console.log("-*-readAppState End", Date.now() - launchStartTime);

                cb && cb();
            }, function (e) {
                console.log("-*-readAppState readTextAsync failure", Date.now() - launchStartTime);
                throw e;
            });
        }, function (e) {
            console.log("-*-readAppState createFileAsync failure", Date.now() - launchStartTime);
            throw e;
        });
    }


    function sendLogEmail() {
        try {        
            var receipient = new Windows.ApplicationModel.Contacts.Contact(),
                emailMessage = new Windows.ApplicationModel.Email.EmailMessage(),
                emailRecipient = new Windows.ApplicationModel.Email.EmailRecipient("windows.support.log@shazam.com");

            emailMessage.subject = "Shazam Log Info";
            emailMessage.body = "Shazam Logging Info\n\n";

            emailMessage.body = "appVersion " + appVersion + " -------------------------------  \n\n";
            emailMessage.body = "log -------------------------------  \n\n";
            emailMessage.body += console.history.join('\n');


            emailMessage.body += "\n\nappState -------------------------------  \n\n";
            emailMessage.body += JSON.stringify(appState,null,4)+'\n';

            emailMessage.to.append(emailRecipient);

            Windows.ApplicationModel.Email.EmailManager.showComposeNewEmailAsync(emailMessage);
        } catch (e) {
           
        }

    }

    /*
    function sendLogEmail() {
       localFolder.getFileAsync('tag.wav').done(function (tagfile) {
            var receipient = new Windows.ApplicationModel.Contacts.Contact(),
                emailMessage = new Windows.ApplicationModel.Email.EmailMessage(),
                emailAttachment = new Windows.ApplicationModel.Email.EmailAttachment(),
                stream = Windows.Storage.Streams.RandomAccessStreamReference.createFromFile(tagfile),
                attachment = new Windows.ApplicationModel.Email.EmailAttachment('tag.wav', stream);

            var emailRecipient = new Windows.ApplicationModel.Email.EmailRecipient("windows.support.log@shazam.com");

            emailMessage.subject = "Shazam Log Info";
            emailMessage.body = "Shazam Logging Info";

            emailMessage.to.append(emailRecipient);
            emailMessage.attachments.append(attachment);
            
            Windows.ApplicationModel.Email.EmailManager.showComposeNewEmailAsync(emailMessage);   
        });
    }
    */


    function writeAppState() {
        console.log("*~*writeAppState Start: ", Date.now() - launchStartTime);
        localFolder.createFileAsync(appStateFileName, Windows.Storage.CreationCollisionOption.openIfExists)
        .done(function (appStateFile) {
            Windows.Storage.FileIO.writeTextAsync(appStateFile, JSON.stringify(appState));
            console.log("*~*writeAppState End: ", Date.now() - launchStartTime);
        }, function (e) {
            console.log('*~*writeAppState fail: ' + e, Date.now() - launchStartTime)
        });
    }

    function reflowWebView() {
        function _reflowView() {
            var webview = document.querySelector("#mainPageFrame");
            if (webview) {
                if (webview.style.overflow == 'hidden') {
                    webview.style.overflow = 'auto';
                } else {
                    webview.style.overflow = 'hidden';
                }
            }
        }
        console.log('-*-reflowView');
        _reflowView();
        setTimeout(_reflowView, 500);
        setTimeout(_reflowView, 2000);
        if (!localStorage['installationId']) {
            setTimeout(_reflowView, 5000);
        }
    }

    function checkForLatestRelease() {
        console.log("*~*checkForLatestRelease Start: ", Date.now() - launchStartTime);
        Internet.ifConnected(function () {
            try {
                var url = "http://cdn.shazam.com/sftv/connect/templates/shazam/";

                url += isBeta ? 'staging.json' : 'prod.json';

                WinJS.xhr({ url: url })
                .done(function complete(result) {
                    var response = result.responseText,
                        current = window.localStorage.webver,
                        release;

                    try {
                        result = JSON.parse(result.responseText);
                    } catch (e) {
                        result = {};
                    }
                    if (appVersion && result.release && (release = result.release[appVersion])) {
                        if (release.url && release.webver) {
                            if (current != release) {

                                var webview = document.createElement("x-ms-webview");
                                WebBridge.on(webview, 'NativeBridge:publish', function (arg) {
                                    window.localStorage.webver = release.webver;
                                    window.localStorage.weburl = release.url;
                                    WebBridge.off(webview);
                                    webview = null;
                                });

                                var url = release.url;
                                webview.src = "ms-appx-web:///proxy.html?url=" + encodeURIComponent(url);


                            }
                        }
                    }
                }, function (e) {

                });
            } catch (e) {

            }
        });
        console.log("*~*checkForLatestRelease End: ", Date.now() - launchStartTime);
    }

    // keep these commented out except for reset flow testing
    //   window.localStorage.removeItem('appData');
    //   window.localStorage.removeItem('installationId');

    function getHardwareId() {
        var id;
        try {
            console.log('-*-getHardwareId');
            var ht = Windows.System.Profile.HardwareIdentification.getPackageSpecificToken(null);

            var reader = Windows.Storage.Streams.DataReader.fromBuffer(ht.id);
            var arr = new Array(ht.id.length);
            reader.readBytes(arr);

            var id = "";
            for (var j = 0; j < arr.length; j++) {
                id += arr[j].toString();
            }
        } catch(e) {

        }
        return id;
    }


    function getAboutData() {
        console.log("*~*getAboutData Start: ", Date.now() - launchStartTime);
        try {
            // Get the top user-preferred language and its display name.
            var topUserLanguage = Windows.System.UserProfile.GlobalizationPreferences.languages[0];
            //            var language = new Windows.Globalization.Language(topUserLanguage);

            var manifestLanguage = topUserLanguage || "en-US";
            var manifestCountry = new Windows.Globalization.GeographicRegion();
        } catch (e) {
            beacon({ type: "getaboutdatafailure1" });
        }

        try {
            var version = Windows.ApplicationModel.Package.current.id.version;
            var shzVersion = version.major + "." + version.minor + "." + version.build + "." + version.revision;
            var osVersion = window.clientInformation.userAgent.match(/Windows (?:Phone |NT )?([0-9.]+)/)[1];
            var deviceInformation = new Windows.Security.ExchangeActiveSyncProvisioning.EasClientDeviceInformation();
            var advertisingId = Windows.System.UserProfile.AdvertisingManager.advertisingId;
            var shazamNowPinned = Windows.UI.StartScreen.SecondaryTile.exists("ShazamNowTile");
        }
        catch (e) {
            beacon({ type: "getaboutdatafailure2" });
            // default version
            shzVersion = '4.2.0.0';
            // need to fire a beacon here
        }

        aboutData = {
                "language": manifestLanguage || "en-US",
                "country": (manifestCountry && manifestCountry.codeTwoLetter) || 'US',
                "client": {
                    "version": shzVersion + ";" + (launchVer || ''),
                    "installationId": installationIdMigration || window.localStorage['installationId'] || null,
                    "channel": window.localStorage['channelBuild']
                },
                "device": {
                    "hardwareid": getHardwareId(),
                    "name": deviceInformation ? deviceInformation.systemSku || deviceInformation.systemProductName : 'Microsoft Virtual',
                    "advertisingid": advertisingId || "",
                    "lowmem":isLowMemoryDevice
                },
                "os": {
                    "name": deviceInformation ? deviceInformation.operatingSystem : "WindowsPhone",
                    "version": osVersion || '8.1'
                },
                "tombstone": tombstone,
                "beta": isBeta,
                "appType": isEncore ? "ENCORE" : "SHAZAM",
                "shazamNowPin": shazamNowPinned,
                "launchStartTime": launchStartTime,
                "supportedCommands": [
                    "location",
                    "xhr",
                    "tag",
                    "pendingTag",
                    "cancelTag",
                    "sharesheet",
                    "get",
                    "set",
                    "appReady",
                    "getAppData",
                    "setAppData",
                    "history",
                    "pushPendingTag",
                    "popPendingTag",
                    "getPendingTagLength",
                    "migration",
                    "testmigration",
                    "pin",
                    "alert",
                    "liveTile",
                    "shutdown",
                    "setAppPath",
                    "refresh",
                    "newWebView",
                    "closeWebView",
                    "mytags",
                    "allowRotation",
                    "playYouTube",
                    "closeYouTube",
                    "youTubeEnded",
                    "authenticate",
                    "ratereview",
                    "resizeWebView",
                    "setNavRect",
                    "resizeYouTube"
                ]
        }
        console.log("*~*getAboutData End: ", Date.now() - launchStartTime);
    }


    function cleanVersion(version) {
        if (!version) { return version; }
        version = version.replace(/[;_]/g, '.');
        version = version.replace(/[a-zA-Z]/g, '');
        version = version.replace(/\.$/, '');
        return version;
    }

    // Send beacon every 10 seconds for 2 minutes. SetInterval cleared if app state moves to 'hidden'
    var tmStartup = setInterval(function () {
        timeVisible += 10;
        startup.time = timeVisible;
        console.log('-*-beacon startupTimeout');
        beacon(startup);

        if (timeVisible >= 120) {
            clearInterval(tmStartup);
        }
    }, 10000)

    function beacon(keyVals) {
        try {
            var params = '';
            keyVals = keyVals || {};

            // example beacon url
            // https://beacon.shazam.com/shazam/4.1.0.18/en/US/windowsphone/{devicemodel}/beacon/{inid}/

            var url = function () {
                try {
                    var ret,
                        lang = aboutData.language || '-',
                        country = aboutData.country || '-',
                        appver = cleanVersion(aboutData.client.version) || '-',
                        device = aboutData.device.name || '-',
                        inid = aboutData.client.installationId || '6B3C5DE0-9777-4FFB-8D1D-E59F6A052A56';

                    // sanitize the device name. '/' were shown to cause issues in the url
                    device = device.replace(/[^A-Za-z0-9-_]/g, '').toLowerCase();

                    if (beaconUrl) {
                        ret = beaconUrl.replace('{devicemodel}', device).replace('{inid}',inid);
                    } else {
                        ret = "http://beacon.shazam.com/shazam/" + appver + "/" + lang + "/" + country + "/windowsphone/" + device + "/beacon/" + inid + "/";
                    }
                    return ret;
                } catch(e) {

                }
            }();

            url = url+"userevent?";

            for (var i in keyVals) {
                params += ((params.length ? '&' : '') + (i + '=' + keyVals[i]));
            }
            url += params;

            // fire the beacon
            WinJS.xhr({ url: url }, function () { }, function () { });
        } catch (e) {

        }
    }

    var videoRect;

    function playYouTube(videoParams) {
        var videoId = videoParams.id, ratio = isPhone ? widthRatio : 1;

        videoRect = videoParams.rect;

        console.log('-*-playYouTube');
        document.body.style.background = 'black';
        youTubeOnScreen = true;

        if (!videoParams.rect && isPhone)
            webview.style.display = 'none';

        if (secondWebView) {
            secondWebViewContainer.style.display = 'none';
        }


        var wgd = Windows.Graphics.Display;
        if (!videoRect && Windows.UI && Windows.UI.ViewManagement && Windows.UI.ViewManagement.StatusBar) {
            var statusBar = Windows.UI.ViewManagement.StatusBar.getForCurrentView();
            wgd.DisplayInformation.autoRotationPreferences = wgd.DisplayOrientations.landscape | wgd.DisplayOrientations.landscapeFlipped;
            statusBar.hideAsync();
        }


        // create the youtube element if it doesn't exist
        if (!youtubeview) {

            youtubeview = document.createElement("div");
            document.body.appendChild(youtubeview);


            youtubeviewInner = document.createElement("x-ms-webview");
            youtubeviewInner.id = "youtubeFrameInner";

            youtubeview.id = "youtubeFrame";
            youtubeview.style.display = 'none';
            youtubeview.style.visibility = 'visible';
            youtubeview.style.zIndex = 15000;

            youtubeview.appendChild(youtubeviewInner);

            youtubeviewInner.addEventListener("MSWebViewScriptNotify", function (e) {
                WebBridge.broadcast(webview, 'NativeBridge:receive', {
                    type: "youTubeEnded"
                });
            });


            youtubeviewInner.addEventListener("MSWebViewNavigationCompleted", function (e) {
                var rect = { left: 0, top: 0, width: window.innerWidth, height: window.innerHeight };
                if (youtubeviewInner.src != "") {
                    youtubeview.style.display = 'block';
                    if (videoRect) {
                        youtubeview.style.top = (videoRect.top * ratio) + 'px';
                        youtubeview.style.left = (videoRect.left * ratio) + 'px';
                        youtubeview.style.width = (videoRect.width * ratio) + 'px';
                        youtubeview.style.height = (videoRect.height * ratio) + 'px';
                    } else {
                        youtubeview.style.width = '';
                        youtubeview.style.height = '';
                        youtubeview.style.top = '0px';
                        youtubeview.style.left = (navRect.left + navRect.width) + 'px';
                        youtubeview.style.right = '0px';
                        youtubeview.style.bottom = '0px';
                    }

                    // autoplay
                    setTimeout(function () {

                        var postmessage = "window.postMessage('{\"event\":\"command\",\"func\":\"playVideo\"}',\"*\");",
                            op = youtubeviewInner.invokeScriptAsync("eval", [postmessage]);
                        op.start();


                        var stateChange = "var videoTag=document.querySelector('video'); videoTag.onended=function(e) { window.external.notify('videoEnded');videoTag.style.display='none';};";
                        op2 = youtubeviewInner.invokeScriptAsync("eval", [stateChange]);
                        op2.start();


                    }, 2000);


                }
            });



        }

        
        var dest = new Windows.Foundation.Uri("https://www.youtube.com/embed/" + videoId + "?fs=0&autoplay=1&enablejsapi=1" + (isLowMemoryDevice ? "&vq=small" : ''));
        var request = new Windows.Web.Http.HttpRequestMessage(Windows.Web.Http.HttpMethod.get, dest);
        var value = new Windows.Foundation.Uri("http://shazam.com/");

        request.headers.referer = value;
        youtubeviewInner.navigateWithHttpRequestMessage(request);

 
    }

    function showSecondWebView(params) {
        var url, ratio = isPhone ? widthRatio : 1;
        console.log('-*-showSecondWebview');
        // create the webview/ container
        if (!secondWebView) {
            secondWebViewContainer = document.querySelector("#secondWebViewContainer");
            secondWebView = document.createElement("x-ms-webview");
            secondWebView.id = 'secondWebView';
            secondWebViewContainer.appendChild(secondWebView);
            WebBridge.on(secondWebView, 'NativeBridge:publish', function (arg) {
                if (arg.type && bridgeCommands[arg.type]) {
                    bridgeCommands[arg.type](arg.data);
                }
            });
        }

        if (params.rect) {
            // position but proportional to device space
            secondWebViewContainer.style.top = (params.rect.top * ratio) + 'px'; // Removed batteryBarOffset
            secondWebViewContainer.style.left = (params.rect.left * ratio) + 'px';
            secondWebViewContainer.style.width = (params.rect.width * ratio) + 'px';
            secondWebViewContainer.style.height = (params.rect.height * ratio) + 'px';
            secondWebViewFullScreen = false;
        } else {
            // fullscreen
            secondWebViewContainer.style.width = 'auto';
            secondWebViewContainer.style.height = 'auto';
            secondWebViewContainer.style.top = navRect.top + 'px'; // Removed batterBarOffset
            secondWebViewContainer.style.left = navRect.width + 'px';
            secondWebViewContainer.style.right = '0px';
            secondWebViewContainer.style.bottom = '0px';
            secondWebViewFullScreen = true;
        }

        // html content specified
        if (params.content) {
            secondWebView.navigateToString(params.content);
        } else if (params.url) {
            url = params.url;
            // The domain needs to be https for cross frame communication
            // the shazam.com domain is listed in the app manifest under content URIs
            if (url.match(/^http:\/\/www\.shazam.com\//)) {
                url = url.replace(/^http:/, 'https:');
            }
            try {
                secondWebView.src = url;
            } catch (e) {
                return;
            }

            function handler(eventInfo) {
                secondWebView.removeEventListener("MSWebViewDOMContentLoaded", handler);

                var script = 'window.WebViewJavascriptBridge = new ' + WebViewJavascriptBridge.toString(),
                    op = secondWebView.invokeScriptAsync("eval", [script]);
                op.start();
            }

            secondWebView.addEventListener("MSWebViewDOMContentLoaded", handler);
        }
        // ensure youTube is not on screen
        if (!youTubeOnScreen)
            secondWebViewContainer.style.display = "block";
        
        secondWebViewOnScreen = true;
    }


    function broadcastAboutBridge() {
        console.log('-*-broadcastAboutBridge');
        WebBridge.broadcast(webview, 'NativeBridge:receive', {
            type: 'aboutBridge',
            data: aboutData
        });
    }

    function getResponseHeaders(data) {
        var headers = {};
        try {
            if (data.getAllResponseHeaders) {
                var responseHeaders = data.getAllResponseHeaders();
                responseHeaders = responseHeaders.split(/\n/g);
                responseHeaders.forEach(function (hd) {
                    var item = hd.split(': '),
                        key = (item[0] ? item[0].replace(/\r+$/g, "").replace(/\n+$/g, "") : null);
                    if (key) {
                        // remove trailing whitespace, and newline characters
                        headers[key] = (item[1] ? item[1].replace(/\s+$/g, "").replace(/\r+$/g, "").replace(/\n+$/g, "") : '') || '';
                    }
                });
            }
        } catch (e) {
            headers = {};
        }
        return headers || {};
    }


    var bridgeCommands = {
        'aboutBridge': function (arg) {
            console.log("*~*aboutBridge Start: ", Date.now() - launchStartTime);
            // if we don't have an installation id / and version 3x migration
           if ((!window.localStorage['installationId'] ||
                !migrationAttempted) &&
                navigator.onLine) {
                getMigrationData(broadcastAboutBridge);
            // migration to 4.1
            } else if (!migrated4_1) {
                migrate4_1(broadcastAboutBridge)
            } else {
                broadcastAboutBridge();
            }
           startup.firedAboutBridge = true;
           console.log("*~*aboutBridge End: ", Date.now() - launchStartTime);
        },
        'appReady': function (arg) {
            console.log("*~*appReady Start: ", Date.now() - launchStartTime);
            // remove the startup timeout beacon
            clearInterval(tmStartup);

            webview.style.visibility = "visible";
            reflowWebView();
            webappReady = true;

            shazamCore && shazamCore.startCapture();
            processTile();
            processVoiceCommand();
            startup.firedAppReady = true;
            console.log("*~*appReady Start: ", Date.now() - launchStartTime);

            if (authenticationResult) {
                WebBridge.broadcast(webview, 'NativeBridge:receive', {
                    type: "authenticationResult",
                    data: authenticationResult
                });
                authenticationResult = false;
            }
            if (deepLinkResult) {
                WebBridge.broadcast(webview, 'NativeBridge:receive', {
                    type: "deepLinkResult",
                    data: deepLinkResult
                });
                deepLinkResult = false;
            }
        },
        'shutdown': function (arg) {
            window.close();
        },
        'mytags': function (args) {
            startup.firedMyTags = true;

            args = args || {};
            var mytags = (appState && appState['mytags']) || [],
                command = args.command,
                start = args.start || 0,
                count = args.count || 20,
                removeIndex,
                tags = [];

            switch (command) {
                case 'get':
                    args.tags = mytags.slice(start, start + count);
                    args.total = mytags.length;

                    WebBridge.broadcast(webview, 'NativeBridge:receive', {
                        type: "mytags",
                        data: args
                    });
                    break;
                case 'add':
                    mytags = args.tags.concat(mytags);
                    // store it back
                    appState['mytags'] = mytags;
                    writeAppState();

                    break;

                case 'update':
                    mytags.some(function (item, index) {
                        if (item && item.id && item.id == args.tag.id) {
                            mytags[index] = args.tag;
                            return true;
                        }
                    });
                    // store it back
                    appState['mytags'] = mytags;
                    writeAppState();
                    break;

                case "remove":
                    mytags.some(function (item, index) {
                        if (item && item.id && item.id == args.tagid) {
                            removeIndex = index;
                            return true;
                        }
                    });
                    mytags.splice(removeIndex, 1);
                    // store it back
                    appState['mytags'] = mytags;
                    writeAppState();
                    break;
            }


        },
        'authenticate': function (arg) {
            console.log(arg.url);
            if (arg.url) {
                try {
                    var requestUri = new Windows.Foundation.Uri(arg.url);
                    Windows.Security.Authentication.Web.WebAuthenticationBroker.authenticateAndContinue(requestUri);
                } catch(e) {

                }
            }
        },
        'authenticationResult': function (arg) {
            WebBridge.broadcast(webview, 'NativeBridge:receive', {
                type: "authenticationResult",
                data: arg
            });
        },
        'alert': function (arg) {
            if (arg) {
                document.body.classList.add('splashon');

                function _complete(selected) {
                    var alertPayload = { payload: arg };
                    if (selected) {
                        alertPayload.selection = selected;
                    }
                    WebBridge.broadcast(webview, 'NativeBridge:receive', {
                        type: 'alertComplete',
                        data: alertPayload
                    });
                };

                if (arg.commands && (arg.body || arg.title)) {
                    alert(arg.body || '', arg.title || '', arg.commands, _complete)
                }
                else if (arg.body || arg.title) {
                    alert(arg.body || '', arg.title || '', null, _complete);
                }
                else {
                    alert(arg, '', null, _complete);
                }

            }
        },
        'tag': function (arg) {
            shazamCore.tag(JSON.stringify(arg)).then(function (res) {
                var response,
                    tag,
                    pendingTag;
                try {
                    response = JSON.parse(res) || {};
                    tag = response.tag;
                    pendingTag = response.pendingTag;
                } catch (e) {}

                console.log(res);

                if (tag || pendingTag) {
                    console.log('-*-tagBroadcast');
                    WebBridge.broadcast(webview, 'NativeBridge:receive', {
                        type: tag ? 'tag' : 'pendingTag',
                        data: tag || pendingTag
                    },
                    function () {
                    });
                }
            });
        },
        'testmigration': function (arg) {
            migrationTest(arg);
        },
        'pushPendingTag': function (arg) {
            var pendingTags = appState['pendingTags'] || [];
            pendingTags.push(arg);
            appState['pendingTags'] = pendingTags;
            writeAppState();
        },


        'setNavRect': function(params) {
            navRect = params;
        },

        'resizeYouTube': function (params) {
            var rect=params.rect;
            if (youtubeview && rect) {
                youtubeview.style.top = (rect.top * widthRatio) + 'px';
                youtubeview.style.left = (rect.left * widthRatio) + 'px';
                youtubeview.style.width = (rect.width * widthRatio) + 'px';
                youtubeview.style.height = (rect.height * widthRatio) + 'px';
            }
        },
        'resizeWebView':function(params) {
            var rect = params.rect;
            if (secondWebViewContainer && rect) {
                secondWebViewContainer.style.top = (rect.top * widthRatio) + 'px';
                secondWebViewContainer.style.left = (rect.left * widthRatio) + 'px';
                secondWebViewContainer.style.width = (rect.width * widthRatio) + 'px';
                secondWebViewContainer.style.height = (rect.height * widthRatio) + 'px';
            }
        },
        'newWebView': function (params) {
            var url = params.url;
                     
            params = params || {};
            if (url) {
                console.log(url);
                if (params.external) {
                    url = new Windows.Foundation.Uri(params.url);
                    Windows.System.Launcher.launchUriAsync(url);
                } else if (params.deeplink) {
                    if (!deeplinkView) {
                        deeplinkView = document.createElement("x-ms-webview");
                    }
                    deeplinkView.src = url;
                } else {
                    showSecondWebView(params);
                }
            } else if (params.content) {
                showSecondWebView(params);
            }

        },

        'closeWebView': function (params) {
            if (secondWebViewContainer) {
                secondWebViewContainer.style.display = "none";
                secondWebView.navigateToString("");
                secondWebViewOnScreen = false;
                secondWebViewFullScreen = false;
            }
        },

        'popPendingTag': function (arg) {
            var pendingTags = appState['pendingTags'] || [],
                pendingTag = pendingTags.shift();

            if (pendingTag) {
                WebBridge.broadcast(webview, 'NativeBridge:receive', {
                    type: 'popPendingTag',
                    data: {
                        pendingTag: pendingTag,
                        remainingCount: pendingTags.length
                    }
                });
                appState['pendingTags'] = pendingTags;
                writeAppState();
            }
        },
        'getPendingTagLength': function () {
            var pendingTags = appState['pendingTags'] || [],
                len = pendingTags.length;

            if (len) {
                WebBridge.broadcast(webview, 'NativeBridge:receive', {
                    type: 'getPendingTagLength',
                    data: len
                });
            }
        },
        'history': function (arg) {
            history = arg;
            insideBack = false;
            if (youTubeOnScreen && !videoRect)
                closeYouTube();

            if (secondWebViewFullScreen) {
                bridgeCommands.closeWebView();
            }

            return; // don't allow the web back button
            if (!isPhone && history && (history.length>2)) {
                if (!backButton) {
                    backButton = document.createElement('div');
                    backButton.classList.add('back-button');
                    document.body.appendChild(backButton);
                    backButton.innerHTML = "<";

                    backButton.addEventListener('click', function (e) {
                        WebBridge.broadcast(webview, 'NativeBridge:receive', {
                            type: 'back',
                            data: {}
                        });

                    });

                }
                backButton.classList.add('visible');
            } else {
                if (backButton)
                    backButton.classList.remove('visible');
            }


        },
        'xhr': function (arg) {
            console.log(arg.url);
            var complete = function (result) {
                console.log('xhr complete ' + result.status);
                var headers = getResponseHeaders(result);
                WebBridge.broadcast(webview, 'NativeBridge:receive', {
                    type: 'xhr',
                    data: {
                        url: arg.url,
                        status: result.status,
                        responseHeaders: headers,
                        responseText: result.response
                    }
                });
            }
            WinJS.xhr(arg).done(complete, function (result) {
                console.log('xhr fail: ' + result);
                complete(result);
            });
        },
        'cancelTag': function (arg) {
            shazamCore && shazamCore.cancelTag();

        },
        'location': function (arg) {
            try {
                var loc = new Windows.Devices.Geolocation.Geolocator();
                loc.getGeopositionAsync().then(function (pos) {
                    try {
                        var coord = pos.coordinate,
                            civicAddress = pos.civicAddress = {};

                        console.log('-*-locationBroadcast');
                        WebBridge.broadcast(webview, 'NativeBridge:receive', {
                            type: 'location',
                            data: {
                                latitude: coord.latitude,
                                longitude: coord.longitude,
                                accuracy: coord.accuracy,
                                city: civicAddress.city,
                                state:civicAddress.state,
                                country: civicAddress.country
                            }
                        });
                    } catch (e) {
                        console.log('location: post getGeoAsync ' + pos);
                    }
                });
            } catch (e) {
                console.log('location: Geolocator');
            }
        },
        'sharesheet': function (arg) {
            sharedata = arg;
            setTimeout(function () {
                Windows.ApplicationModel.DataTransfer.DataTransferManager.showShareUI();
            }, 1);
        },
        'ratereview': function (arg) {
            var storeUrl = isPhone ? "ms-windows-store:reviewapp?appid=" : "ms-windows-store://review/?AppId=";
            Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(storeUrl + Windows.ApplicationModel.Store.CurrentApp.appId));
        },
        'pin': function (arg) {
            if (arg.tileId == 'listennow') {
                pinShazamNowTile(arg.tileText);
            }
        },
        'setAppData': function (arg) {
            var installationId;
            try {
                installationId = arg.aboutBridge.client.installationId;
                window.localStorage['installationId'] = installationId;
            } catch (e) {
            }

            try {
                beaconUrl = arg.ampConfig.data.apis.beacon.href;

            } catch (e) {

            }
            startup.firedSetAppData = true;

            try {
                window.localStorage['appData'] = arg && JSON.stringify(arg);
            } catch (e) {
                console.log('setAppData: local storage failure ' + arg);
            }
        },
        'getAppData': function (arg) {
            var result;
            try {
                if (window.localStorage["appData"]) {
                    result = JSON.parse(window.localStorage["appData"]);
                } else {
                    result = null;
                }
            }
            catch (e) {
                result = {};
            }
            startup.firedGetAppData;

            WebBridge.broadcast(webview, 'NativeBridge:receive', {
                type: 'getAppData',
                data: result
            });
        },

        'set': function (arg) {
            if (arg.key && arg.value) {
                appState[arg.key] = arg.value;
                writeAppState();
            }
        },
        'get': function (arg) {
            if (arg) {
                WebBridge.broadcast(webview, 'NativeBridge:receive', {
                    type: 'get',
                    data: {
                        key: arg,
                        value: appState && appState[arg]
                    }
                });
            }
        },
        'webError': function (arg) {
            //alert(arg.msg);
        },
        'liveTile': function (arg) {
            liveTileNotification(arg.header, arg.title, arg.subTitle);
        },
        'setAppPath': function (arg) {
            if (arg) {
                //set local storage betaAppPath
                window.localStorage['betaAppPath'] = arg;
            } else {
                if (window.localStorage['betaAppPath']) {
                    delete window.localStorage['betaAppPath'];
                }
            }
        },
        'refresh': function (arg) {
            webview && webview.refresh();
        },
        'allowRotation': function (arg) {
            try {
                var wgd = Windows.Graphics.Display;
                var statusBar = Windows.UI.ViewManagement.StatusBar.getForCurrentView();
                if (arg) {
                    wgd.DisplayInformation.autoRotationPreferences = wgd.DisplayOrientations.landscape/* | wgd.DisplayOrientations.portrait */ | wgd.DisplayOrientations.landscapeFlipped;
                    statusBar.hideAsync();
                } else {
                    wgd.DisplayInformation.autoRotationPreferences = wgd.DisplayOrientations.portrait;
                    statusBar.showAsync();
                }
            } catch (e) {
                // need to beacon
            }
        },
        'playYouTube': function (videoId) {
            playYouTube(videoId);            
        },
        'closeYouTube': function () {
            closeYouTube();
        }
    }

    function closeYouTube() {
        console.log('-*-closeYouTube');
        document.body.style.background = '#0088FF';
        if (youtubeview) {
            youtubeview.style.display = 'none';
            youtubeviewInner.navigateToString("");
        }
        youTubeOnScreen = false;
        webview.style.display = 'block';
        if (secondWebViewContainer && secondWebViewOnScreen) {
            secondWebViewContainer.style.display = "block";
        }
        try {
            var wgd = Windows.Graphics.Display;
            if (Windows.UI && Windows.UI.ViewManagement && Windows.UI.ViewManagement.StatusBar) {
                var statusBar = Windows.UI.ViewManagement.StatusBar.getForCurrentView();
                wgd.DisplayInformation.autoRotationPreferences = wgd.DisplayOrientations.portrait;
                statusBar.showAsync();
            }
        } catch (e) {
            // need to beacon
        }
    }


    function createWebView(url) {
        console.log("*~*createWebView Start: ", Date.now() - launchStartTime);
        console.log("createWebView - " + url);
        webview = document.createElement("x-ms-webview");
        webview.id = "mainPageFrame";


        if (Windows.Phone) {
            isPhone = true;
            var backButton = Windows.Phone.UI.Input.HardwareButtons,
                event = "backpressed";
        } else if(Windows.UI.Core.SystemNavigationManager){
            //Desktop environment
            var systemNavigation = Windows.UI.Core.SystemNavigationManager.getForCurrentView();
            systemNavigation.appViewBackButtonVisibility = 'visible';
            var backButton = systemNavigation,
                event = "backrequested";
        }
        backButton.addEventListener(event, function (e) {
            console.log('-*-backpressed');
            if (webview.canGoBack) {
                webview.goBack();
                e.handled = true;
                return;
            }
            if (secondWebViewFullScreen && secondWebView.canGoBack) {
                secondWebView.goBack();
                e.handled = true;
                return;
            }

            // if the youtubevideo is present
            if (youtubeview && youtubeview.style.display != 'none' && !videoRect) {
                closeYouTube();
                e.handled = true;
            }
            else if (history.length > 1) {

                if (!insideBack) {
                    if (secondWebViewFullScreen) {
                        bridgeCommands.closeWebView();
                    } else {
                        WebBridge.broadcast(webview, 'NativeBridge:receive', {
                            type: 'back',
                            data: {}
                        });
                        insideBack = true;
                    }
                    secondWebViewFullScreen = false;
                }
                e.handled = true;

            // The scenario: cold start, click on login, click back.
            } else if (history.length == 1 && secondWebViewFullScreen) {
                bridgeCommands.closeWebView();
                e.handled = true;
            }
        });

        // argumeunts are url / type (optional) / payload (optional)
        WebBridge.on(webview, 'NativeBridge:publish', function (arg) {
            if (arg.type && bridgeCommands[arg.type]) {
                console.log(arg.type);
                bridgeCommands[arg.type](arg.data);
            }
        });

        // DEBUG
        //      url = "http://{IPADDRESS}/sftv/public/shazam.html#apps.shazam;activepage=apps.shazam.listen;console=1";

    //    url = "http://172.22.0.111/sftv/public/shazam.html#apps.shazam;activepage=apps.shazam.listen;console=1";
     //   url = "http://172.22.0.89/sftv/public/shz.html";
        try {
            if (isBeta && window.localStorage['betaAppPath']) {
                url = window.localStorage['betaAppPath'];
           } 
        } catch (err) { }

        webview.src = "ms-appx-web:///proxy.html?url=" + encodeURIComponent(url);
        document.body.insertBefore(webview, document.body.firstChild);
        //   webview.style.visibility = "visible";
        console.log("*~*createWebView End: ", Date.now() - launchStartTime);
    }



    function _setupLoading() {
        console.log("*~*_setupLoading Start: ", Date.now() - launchStartTime);
        try {
            var lang = Windows.System.UserProfile.GlobalizationPreferences.languages[0].toLowerCase(),
                langDetails = lang.split('-'),
                country = langDetails.length > 1 ? langDetails.pop() : '',
                justLang = langDetails.join('-').toLowerCase(),
                langPath,
                _supportedIntlLocales = ['en-gb','pt-pt'];
                
            langPath = _supportedIntlLocales.indexOf(lang) >= 0 ? lang : justLang;

            var loading = loadingStrings[langPath] || "Loading";
            document.querySelector('.loading .title').innerHTML = loading;
        }
        catch (e) { }
        console.log("*~*_setupLoading Start: ", Date.now() - launchStartTime);
    }

    function initializeApp() {
        console.log("-*-initializeApp start: ", Date.now() - launchStartTime);

        if (!initialized) {

            // start native mic/rec object
            try {
                window.shazamCore = new ShazamCore.API();
                window.shazamCore.startup();


                isLowMemoryDevice = window.shazamCore.isLowMemoryDevice();
            } catch (e) {
                console.log('-*-shazamCoreFail ' + e);
            }

            // setup loading
            _setupLoading();

            // crack the package name
            try {
                var version = Windows.ApplicationModel.Package.current.id.version;
                var shzVersion = version.major + "." + version.minor + "." + version.build + "." + version.revision;
                var name = Windows.ApplicationModel.Package.current.id.name || '';

            } catch (e) {
                name = '';
            }

            isBeta = (name.toLowerCase().indexOf('beta') >= 0);
            isEncore = (name.toLowerCase().indexOf('encore') >= 0);

            if (isChannelBuild) {
                window.localStorage['channelBuild'] = "channel";
            }

            // build the aboutData
            getAboutData();

            document.body.addEventListener('pointerup', function (e) {
                reflowWebView();
            });

            // force using the local file on a change of application version
            if (appVersion != shzVersion) {
                window.localStorage['appVersion'] = shzVersion;
                delete window.localStorage['webver'];
                delete window.localStorage['weburl'];
            }

            var url, weburl = window.localStorage.weburl;
            if (weburl) {
                url = weburl;
                launchVer = window.localStorage.webver;
            } else {
                url = localUrl;
                launchVer = 'local';
            }
            createWebView(url);

            //setTimeout(checkForLatestRelease, checkForLatestDelay);

            //Show status bar.
            var applicationView = Windows.UI.ViewManagement.ApplicationView.getForCurrentView();
            if (!Windows.Phone) {
                applicationView.setPreferredMinSize({ height: 500, width: 500 });
                applicationView.titleBar.backgroundColor = { a: .2, r: 0, g: 101, b: 187 };
                applicationView.titleBar.foregroundColor = { a: 0, r: 255, g: 255, b: 255 };
                applicationView.titleBar.buttonBackgroundColor = { a: .2, r: 0, g: 101, b: 187 };
                applicationView.titleBar.buttonForegroundColor = { a: 0, r: 255, g: 255, b: 255 };
                applicationView.titleBar.buttonHoverBackgroundColor = { a: .2, r: 0, g: 136, b: 255 };
                applicationView.titleBar.buttonHoverForegroundColor = { a: 0, r: 255, g: 255, b: 255 };
            }

            if (Windows.Phone) {
                applicationView.addEventListener("visibleboundschanged", function () {
                    console.log('-*-visibleboundschanged');
                    var bounds = applicationView.visibleBounds;

                    if (!batteryBarOffset) {
                        batteryBarOffset = bounds.y;
                    }

                    if (webview) {
                        //webview.style.top = Math.ceil(bounds.y)+'px';
                        webview.style.height = Math.ceil(bounds.height + batteryBarOffset) + 'px';
                    }
                    /*     
                         if (youtubeview) {
                             youtubeview.style.left = bounds.x + 'px';
                             youtubeview.style.top = bounds.y + 'px';
                             youtubeview.style.height = bounds.height + 'px';
                             youtubeview.style.width = bounds.width + 'px';
                         }
                         */
                });
            }

            // set the view bounds and the status bar color
            applicationView.setDesiredBoundsMode(Windows.UI.ViewManagement.ApplicationViewBoundsMode.useCoreWindow);
            if (Windows.UI && Windows.UI.ViewManagement && Windows.UI.ViewManagement.StatusBar) {
                var statusBar = Windows.UI.ViewManagement.StatusBar.getForCurrentView();
                statusBar.backgroundOpacity = 0;
                statusBar.backgroundColor = { a: 255, r: 0, g: 118, b: 201 };
                statusBar.showAsync();
            }

            if (Windows.Devices.Input.KeyboardCapabilities) {
                var keyBoardCapabilities = new Windows.Devices.Input.KeyboardCapabilities();
                if (keyBoardCapabilities.keyboardPresent) {
                    document.body.onkeydown = function (event) {
                        var key_press = String.fromCharCode(event.keyCode);
                        var key_code = event.keyCode;
                        switch (event.key) {
                            case "Enter":
                            case " ":
                                if (webview && webappReady) {
                                        WebBridge.broadcast(webview, 'NativeBridge:receive', {
                                            type: 'listennow',
                                            data: { origin: 'keyboard' }
                                        });
                                }
                                break;
                            case "Esc":
                            case "Backspace":
                                if (webview && webappReady) {
                                    WebBridge.broadcast(webview, 'NativeBridge:receive', {
                                        type: 'back',
                                    });
                                }
                                break;
                        }
                    }
                }
            }

            
            // Installation of Voice Commands
            var uri = new Windows.Foundation.Uri("ms-appx:///VoiceCommandDefinition_8.1.xml");
            var storageFile =
                Windows.Storage.StorageFile.getFileFromApplicationUriAsync(uri).then(
                // Success function.
                function (vcd) {
                    if (Windows.Media.SpeechRecognition && Windows.Media.SpeechRecognition.VoiceCommandManager) {
                        Windows.Media.SpeechRecognition.VoiceCommandManager.installCommandSetsFromStorageFileAsync(vcd);
                    } else if (Windows.ApplicationModel.VoiceCommands.VoiceCommandDefinitionManager) {
                        var voiceCommandDefinitionManager = Windows.ApplicationModel.VoiceCommands.VoiceCommandDefinitionManager;
                        voiceCommandDefinitionManager.installCommandDefinitionsFromStorageFileAsync(vcd);
                    }
                },
                // Error function.

                function (err) {
                    WinJS.log && WinJS.log("File access failed.");
                });            

            // Register app for using share sheet.
            var dataTransferManager = Windows.ApplicationModel.DataTransfer.DataTransferManager.getForCurrentView();
            dataTransferManager.addEventListener("datarequested", shareHandler);

        }
        initialized = true;
        console.log("-*-initializeApp End: ", Date.now() - launchStartTime);
    }

    app.onactivated = function (args) {
        var cb;
        console.log("-*-app.onactivated Start: ", Date.now() - launchStartTime);

        if (args.detail && args.detail.webAuthenticationResult) {
            try {
                authenticationResult = args.detail.webAuthenticationResult.responseData;
                if (authenticationResult) {
                    console.log('-*-broadcastAuthResult');
                    WebBridge.broadcast(webview, 'NativeBridge:receive', {
                        type: "authenticationResult",
                        data: authenticationResult
                    });
                    authenticationResult = null;
                }
            } catch (e) { }
        }

        if (args.detail.kind === activation.ActivationKind.launch) {
            console.log('-*-activatedLaunch');
            if ((args.detail.previousExecutionState == activation.ApplicationExecutionState.terminated) ||
               (args.detail.previousExecutionState == activation.ApplicationExecutionState.notRunning)) {
                    tombstone = true;
            }

            if (args.detail.tileId === "ShazamNowTile") {
                activeTile = "ShazamNowTile";
            }
            cb = function() {
                args.setPromise(WinJS.UI.processAll());
            };
            if (!initialized) {
                readAppState(function() {
                    initializeApp();
                    cb();
                });
            } else {
                cb();
            }
        } else if (args.detail.kind === activation.ActivationKind.voiceCommand) {
            console.log('-*-activatedVoice');
            // This application has been activated with a voice command.
            var speechRecognitionResult = args.detail.result;
            // For this example, we declare only one command.
            activeVoiceCommand = speechRecognitionResult.rulePath[0];

            if (!initialized) {
                readAppState(function () {
                    initializeApp();
                });
            } else {
                processVoiceCommand();
            }
            
        } else if (args.detail.kind === Windows.ApplicationModel.Activation.ActivationKind.protocol) {
            console.log('-*-activatedProtocol');
            cb = function () {
                // The received URI is args.detail.uri.rawUri
                try {
                    deepLinkResult = args.detail.uri.rawUri;
                    if (deepLinkResult && webappReady) {
                        WebBridge.broadcast(webview, 'NativeBridge:receive', {
                            type: "deepLinkResult",
                            data: deepLinkResult
                        });
                        deepLinkResult = false;
                    }
                } catch (e) { }
            };
            if (!initialized) {
                readAppState(function () {
                    initializeApp();
                    cb();
                });
            } else {
                cb();
            }
        }
        console.log("-*-app.onactivated End: ", Date.now() - launchStartTime);
    };

    app.ondeactivated = function (args) {

    }

    app.onunload = function (args) {
        try {
            if (window.shazamCore)
                shazamCore.shutdown();
        } catch (e) {
            console.log('-*-onunload shazamCore Fail ' + e);
        }
    }


    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. You might use the
        // WinJS.Application.sessionState object, which is automatically
        // saved and restored across suspension. If you need to complete an
        // asynchronous operation before your application is suspended, call
        // args.setPromise().
    };


    function processVoiceCommand() {
        console.log('-*-processVoiceCommand');
        if (webview && activeVoiceCommand && webappReady) {
            if (activeVoiceCommand.toLowerCase() === "shazamnow") {
                bridgeCommands.closeWebView();
                closeYouTube();
                WebBridge.broadcast(webview, 'NativeBridge:receive', {
                    type: 'listennow',
                    data: { origin: 'cortana' }
                });
            }
            activeVoiceCommand = null;
        }
    }

    function processTile() {
        console.log('-*-processTile');
        if (webview && activeTile && webappReady) {
            bridgeCommands.closeWebView();
            closeYouTube();
            WebBridge.broadcast(webview, 'NativeBridge:receive', {
                type: 'listennow',
                data: { origin: 'deeplink' }
            });
            activeTile = null;
        }
    }

    document.addEventListener('msvisibilitychange', function () {
        console.log('-*-msvischange');
        if (document.visibilityState == 'visible') {
            reflowWebView();
            if (webview && webappReady) {
                WebBridge.broadcast(webview, 'NativeBridge:receive', {
                    type: 'applicationForegrounded',
                    data: null
                });
            }
            processVoiceCommand();
            processTile();
            shazamCore.startCapture();
        }

        if (document.visibilityState == 'hidden') {
            WebBridge.broadcast(webview, 'NativeBridge:receive', {
                type: 'applicationBackgrounded',
                data: null
            });
            shazamCore.stopCapture();

            //    liveTileNotification();
        }
    });

    function migrationTest(numberOfTracks) {
        console.log('-*-migTest');
        var data = [];
        for (var i = 0; i < numberOfTracks; i++) {
            data.push({
                trackid: "5161646",
                timestamp: 1416266529167,
                geolocation: {
                    altitude: "120",
                    latitude: "47.6785619",
                    longitude: "-122.1311156"
                },
                matches: [{}, {
                    frequencyskew: "0.000201344",
                    offset: "12.5389",
                    timeskew: "-0.00179762"
                }],
                track: {
                    heading: {
                        product: "Is This It",
                        subtitle: "The Strokes",
                        title: "Someday"
                    },
                    images: {
                        "default": "http://images.shazam.com/coverart/t5161646_s400.jpg"
                    },
                    key: "5161646",
                    type: "music"
                }
            });
        }
        WebBridge.broadcast(webview, 'NativeBridge:receive', {
            type: 'migration',
            data: {
                update: true,
                data: data
            }
        });
    }

    // index the tags by timestanp/trackid to be used for dupe matching in migration
    function indexMyTags() {
        console.log("*~*indexMyTags Start: ", Date.now() - launchStartTime);
        var index = {},
             mytags = appState && appState['mytags'],
             tag;

        if (mytags) {
            for (var i in mytags) {
                tag = mytags[i];
                if (tag && tag.v2)
                    index[tag.v2.trackid + '_' + tag.v2.timestamp] = tag;
            }
        }
        console.log("*~*indexMyTags End: ", Date.now() - launchStartTime);
        return index;
    }


    function migrate4_1(cb) {
        try {
            console.log('-*-mig4_1');
            var mytags = appState && appState['mytags'],
                 tag;

            if (mytags) {
                for (var i in mytags) {
                    try {
                        tag = mytags[i];
                        if (tag && tag.v2) {
                            // remove the display-action
                            if (tag.v2.track && tag.v2.track.display)
                                delete tag.v2.track.display;

                            // migrate to v3 endpoint
                            tag.v3 = tag.v2;
                            delete tag.v2;
                        }
                    } catch (e) {
                        // advance to next track
                    }
                }
                // store it back
                appState['mytags'] = mytags;
                writeAppState();
            }
        }
        catch (e) {
            // log this
        }
        // one attempt
        window.localStorage["migrated_4_1_1"] = true;
        cb();
    }

    function getMigrationData(cb) {
        console.log("*~*getMigrationData Start: ", Date.now() - launchStartTime);
        var migrationFile = "AppState.xml",
            error = 0;

        // only retry migration once for now - but store # attempts
        window.localStorage['migrationAttempted'] = migrationAttempted ? migrationAttempted++ : 1;

        try {
            Windows.Storage.ApplicationData.current.localFolder.getFileAsync(migrationFile).then(
                function (storageFile) {
                    return Windows.Storage.FileIO.readTextAsync(storageFile);
                }, function (e) {
                    error = 0; //No migration file found.
                })
                .done(function (xmlString) {
                    var myTagsIndex = indexMyTags();
                    var migrationTags = [];
                    if (xmlString) {
                        try {
                            try {
                                //Initialize XML parser.
                                var x2js = new X2JS();
                                json = x2js.xml_str2json(xmlString);

                                installationIdMigration = json.AppState._DeviceId || "";
                            }
                            catch (e) { error = 1; }

                            try {
                                var myTagsArray = json.AppState.MyTags.TagVO || [];
                                var trackMap = {};

                                var tracksArray = json.AppState.Tracks.TrackVO || [];
                                if (Object.prototype.toString.call(tracksArray) !== '[object Array]') {
                                    tracksArray = [tracksArray];
                                }
                                tracksArray.forEach(function (track) {
                                    trackMap[track._Id] = {
                                        type: track._TrackCategory || "",
                                        key: track._Id || "",
                                        heading: {
                                            title: track._Title || "",
                                            subtitle: track._Artist || "",
                                            product: track._Product || ""
                                        },
                                        images: {
                                            "default": track._ImageUri || ""
                                        }
                                    };
                                });
                            }
                            catch (e) { error = 2; }

                            // Either a single element or an array, promoting single element to an array of 1.
                            if (myTagsArray._TrackId) {
                                myTagsArray = [myTagsArray]
                            }

                            myTagsArray.forEach(function (tag) {
                                var migrationTag;
                                try {
                                    migrationTag = {
                                        trackid: tag._TrackId || "",
                                        timestamp: Date.parse(tag._Date) || "",
                                        geolocation: {
                                            latitude: tag.Location && tag.Location.LocationGeoPosVO && tag.Location.LocationGeoPosVO._Latitude || "",
                                            longitude:tag.Location && tag.Location.LocationGeoPosVO && tag.Location.LocationGeoPosVO._Longitude || "",
                                            altitude: tag.Location && tag.Location.LocationGeoPosVO && tag.Location.LocationGeoPosVO._Altitude || ""
                                        },
                                        matches: [{}, {
                                            offset: tag.TrackMatchData && tag.TrackMatchData.MatchDataVO && tag.TrackMatchData.MatchDataVO._Offset || "",
                                            timeskew: tag.TrackMatchData && tag.TrackMatchData.MatchDataVO && tag.TrackMatchData.MatchDataVO._TimeSkew || "",
                                            frequencyskew: tag.TrackMatchData && tag.TrackMatchData.MatchDataVO && tag.TrackMatchData.MatchDataVO._FrequencySkew || ""
                                        }],
                                        track: trackMap[tag._TrackId]
                                    };
                                }
                                catch (e) { error = 3; }
                                if (migrationTag) {
                                    // migrationTag has a timestap verify its not a dupe
                                    if (migrationTag.timestamp) {
                                        if (!myTagsIndex[migrationTag.trackid + "_" + migrationTag.timestamp]) {
                                            migrationTags.push(migrationTag);
                                        }
                                    } 
                                }
                            });
                        } catch (err) { error = 4; }
                    }
                    WebBridge.broadcast(webview, 'NativeBridge:receive', {
                        type: 'migration',
                        data: {
                            data: migrationTags,
                            failure: error
                        }
                        
                    });
                    cb();
                });
        } catch (err) {
            WebBridge.broadcast(webview, 'NativeBridge:receive', {
                type: 'migration',
                data: {
                    data: [],
                    failure: 5
                }
            });
            cb();
        }
        console.log("*~*getMigrationData Start: ", Date.now() - launchStartTime);
    }

    function shareHandler(e) {
        try {
            console.log('-*-shareHandler');
            var request = e.request,
                title,
                url,
                temp;
            if (sharedata.text) {
                title = sharedata.text;
            }
            if (sharedata.title) {
                title = sharedata.title;
            }
            url = sharedata.url;

            // Shazam.com doesn't provide us with an explicit url, so try to find one
            if (!url) {
                temp = title.split(' ');
                temp.some(function (item) {
                    if (item.indexOf('http') == 0) {
                        url = item;
                        return true;
                    }
                });
                // If we found one let's not show it twice
                if (url) {
                    title = title.replace(url, '');
                }
            }

            request.data.properties.title = title || "I discovered this using Shazam!";
            if (url) {
                request.data.setUri(new Windows.Foundation.Uri(url));
            }
        }
        catch(e) {

        }
    }

    function liveTileNotification(header, title, subtitle) {
        console.log('-*-liveTileNotif');
        var notifications = Windows.UI.Notifications;

        var template = notifications.TileTemplateType.tileWide310x150PeekImage01;
        var tileXml = notifications.TileUpdateManager.getTemplateContent(template);

        var tileTextAttributes = tileXml.getElementsByTagName("text");
        tileTextAttributes[0].appendChild(tileXml.createTextNode(header));
        tileTextAttributes[1].appendChild(tileXml.createTextNode(title + "\n" + subtitle));
        var tileImageAttributes = tileXml.getElementsByTagName("image");
        tileImageAttributes[0].setAttribute("src", "ms-appx:///images/Wide310x150Logo.scale-240.png");

        var squareTemplate = notifications.TileTemplateType.tileSquare150x150PeekImageAndText04;
        var squareTileXml = notifications.TileUpdateManager.getTemplateContent(squareTemplate);
        var squareTileTextAttributes = squareTileXml.getElementsByTagName("text");
        squareTileTextAttributes[0].appendChild(squareTileXml.createTextNode(header + "\n"));
        squareTileTextAttributes[0].appendChild(squareTileXml.createTextNode(title + "\n" + subtitle));
        var squareTileImageAttributes = squareTileXml.getElementsByTagName("image");
        squareTileImageAttributes[0].setAttribute("src", "ms-appx:///images/Square150x150Logo.scale-240.png");

        var node = tileXml.importNode(squareTileXml.getElementsByTagName("binding").item(0), true);
        tileXml.getElementsByTagName("visual").item(0).appendChild(node);

        var tileNotification = new notifications.TileNotification(tileXml);

        var currentTime = new Date();
        // Not setting an expiration time defaults to never expire.
        //tileNotification.expirationTime = new Date(currentTime.getTime() + 600 * 1000);

        notifications.TileUpdateManager.createTileUpdaterForApplication().update(tileNotification);

    }

    function pinShazamNowTile(tileText) {
        console.log('-*-pinShazamNow');
        var tileId = "ShazamNowTile";

        // Prepare package images for all four tile sizes in our tile to be pinned as well as for the square30x30 logo used in the Apps view.
        var square71x71Logo = new Windows.Foundation.Uri("ms-appx:///Images/square71x71Logo.scale-240.png");
        var square150x150Logo = new Windows.Foundation.Uri("ms-appx:///Images/square150x150Logo.scale-240.png");
        var wide310x150Logo = new Windows.Foundation.Uri("ms-appx:///Images/wide310x150Logo.scale-240.png");
        var square44x44Logo = new Windows.Foundation.Uri("ms-appx:///Images/Square44x44Logo.scale-240.png");

        // Get the current time...
        var currentTime = new Date();

        // Now, to make this explicit and highly readable, assign current time plus some name to a variable called tileActivationArguments
        var newTileActivationArguments = tileId + " WasPinnedAt=" + currentTime;

        // Create a Secondary tile with all the required arguments.       
        var tile = new Windows.UI.StartScreen.SecondaryTile(tileId,
            tileText,
            newTileActivationArguments,
            square150x150Logo,
            Windows.UI.StartScreen.TileSize.Square150x150);

        tile.visualElements.wide310x150Logo = wide310x150Logo;
        tile.visualElements.square70x70Logo = square71x71Logo;

        // The display of the secondary tile name can be controlled for each tile size.`
        tile.visualElements.showNameOnSquare150x150Logo = true;
        tile.visualElements.showNameOnWide310x150Logo = true;
        tile.visualElements.showNameOnSquare310x310Logo = true;

        // Set this to false if roaming doesn't make sense for the secondary tile.
        // The default is true;
        tile.roamingEnabled = false;

        // We now are ready to try and pin the tile.
        tile.requestCreateAsync().done(function (isCreated) {
            if (isCreated) {
                // The tile was successfully created, so we'll display a status message
                WinJS.log && WinJS.log("Secondary tile was successfully pinned.", "sample", "status");
            } else {
                // something happened - either the user cancelled, or an error was encountered.
                // Either way, the flyout is now gone, and we'll react the same way.
                WinJS.log && WinJS.log("Secondary tile was not pinned.", "sample", "error");
            }
        });
    }

    app.start();
})();